com.fasterxml.jackson.core

## Interface PrettyPrinter

All Known Implementing Classes:
  DefaultPrettyPrinter, MinimalPrettyPrinter

    public interface PrettyPrinter

Interface for objects that implement pretty printer functionality, such as indentation. Pretty printers are used to add white space in output JSON content, to make results more human readable. Usually this means things like adding linefeeds and indentation.

Note: since Jackson 2.1, stateful implementations MUST implement `Instantiatable` interface, to allow for constructing per-generation instances and avoid state corruption (see [JACKSON-851] for details). Stateless implementations need not do this; but those are less common.

### Method Summary

Methods
`void` `beforeArrayValues(JsonGenerator jg)` Method called after array start marker has been output, and right before the first value is to be output.
`void` `beforeObjectEntries(JsonGenerator jg)` Method called after object start marker has been output, and right before the field name of the first entry is to be output.
`void` `writeArrayValueSeparator(JsonGenerator jg)` Method called after an array value has been completely output, and before another value is to be output.
`void` `writeEndArray(JsonGenerator jg, int nrOfValues)` Method called after an Array value has been completely output (minus closing bracket).
`void` `writeEndObject(JsonGenerator jg, int nrOfEntries)` Method called after an Object value has been completely output (minus closing curly bracket).
`void` `writeObjectEntrySeparator(JsonGenerator jg)` Method called after an object entry (field:value) has been completely output, and before another value is to be output.
`void` `writeObjectFieldValueSeparator(JsonGenerator jg)` Method called after an object field has been output, but before the value is output.
`void` `writeRootValueSeparator(JsonGenerator jg)` Method called after a root-level value has been completely output, and before another value is to be output.
`void` `writeStartArray(JsonGenerator jg)` Method called when an Array value is to be output, before any member/child values are output.
`void` `writeStartObject(JsonGenerator jg)` Method called when an Object value is to be output, before any fields are output.

### Method Detail

#### writeRootValueSeparator

    void writeRootValueSeparator(JsonGenerator jg)
                                 throws IOException,
                                        JsonGenerationException

Method called after a root-level value has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a space, to allow values to be parsed correctly. Pretty-printer is to output some other suitable and nice-looking separator (tab(s), space(s), linefeed(s) or any combination thereof).

Throws:
  `IOException`
  `JsonGenerationException`

#### writeStartObject

    void writeStartObject(JsonGenerator jg)
                          throws IOException,
                                 JsonGenerationException

Method called when an Object value is to be output, before any fields are output.

Default handling (without pretty-printing) will output the opening curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

Throws:
  `IOException`
  `JsonGenerationException`

#### writeEndObject

    void writeEndObject(JsonGenerator jg,
                      int nrOfEntries)
                        throws IOException,
                               JsonGenerationException

Method called after an Object value has been completely output (minus closing curly bracket).

Default handling (without pretty-printing) will output the closing curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

Parameters:
  `nrOfEntries` - Number of direct members of the array that have been output
Throws:
  `IOException`
  `JsonGenerationException`

#### writeObjectEntrySeparator

    void writeObjectEntrySeparator(JsonGenerator jg)
                                   throws IOException,
                                          JsonGenerationException

Method called after an object entry (field:value) has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a single comma to separate the two. Pretty-printer is to output a comma as well, but can surround that with other (white-space) decoration.

Throws:
  `IOException`
  `JsonGenerationException`

#### writeObjectFieldValueSeparator

    void writeObjectFieldValueSeparator(JsonGenerator jg)
                                        throws IOException,
                                               JsonGenerationException

Method called after an object field has been output, but before the value is output.

Default handling (without pretty-printing) will output a single colon to separate the two. Pretty-printer is to output a colon as well, but can surround that with other (white-space) decoration.

Throws:
  `IOException`
  `JsonGenerationException`

#### writeStartArray

    void writeStartArray(JsonGenerator jg)
                         throws IOException,
                                JsonGenerationException

Method called when an Array value is to be output, before any member/child values are output.

Default handling (without pretty-printing) will output the opening bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

Throws:
  `IOException`
  `JsonGenerationException`

#### writeEndArray

    void writeEndArray(JsonGenerator jg,
                     int nrOfValues)
                       throws IOException,
                              JsonGenerationException

Method called after an Array value has been completely output (minus closing bracket).

Default handling (without pretty-printing) will output the closing bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

Parameters:
  `nrOfValues` - Number of direct members of the array that have been output
Throws:
  `IOException`
  `JsonGenerationException`

#### writeArrayValueSeparator

    void writeArrayValueSeparator(JsonGenerator jg)
                                  throws IOException,
                                         JsonGenerationException

Method called after an array value has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a single comma to separate the two. Pretty-printer is to output a comma as well, but can surround that with other (white-space) decoration.

Throws:
  `IOException`
  `JsonGenerationException`

#### beforeArrayValues

    void beforeArrayValues(JsonGenerator jg)
                           throws IOException,
                                  JsonGenerationException

Method called after array start marker has been output, and right before the first value is to be output. It is not called for arrays with no values.

Default handling does not output anything, but pretty-printer is free to add any white space decoration.

Throws:
  `IOException`
  `JsonGenerationException`

#### beforeObjectEntries

    void beforeObjectEntries(JsonGenerator jg)
                             throws IOException,
                                    JsonGenerationException

Method called after object start marker has been output, and right before the field name of the first entry is to be output. It is not called for objects without entries.

Default handling does not output anything, but pretty-printer is free to add any white space decoration.

Throws:
  `IOException`
  `JsonGenerationException`